//----------------------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//----------------------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  DarkOrange
#property indicator_color3  LimeGreen
#property indicator_color4  DarkOrange
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    SmoothPeriod    = 40;
extern bool   HistoOnFirst    = false;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;


double bufferHc[];
double bufferHo[];
double bufferHh[];
double bufferHl[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//----------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,bufferHh); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,bufferHl); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,bufferHc); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,bufferHo); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,trend); 
      
      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
      IndicatorShortName(timeFrameToString(timeFrame)+"   Heiken ashi - super smoother");   
return(0);
}


int deinit() { return(0);}

//----------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------
//
//
//
//
//

double working[][4];
#define _haOpen  0
#define _haClose 1
#define _haHigh  2
#define _haLow   3

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      int i,r,limit;
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { bufferHh[0] = limit+1; return(0); }   
         
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {  
     if (ArrayRange(working,0) != Bars) ArrayResize(working,Bars);         
     for(i=limit, r=Bars-i-1; i >= 0; i--,r++)
     {
        working[r][_haHigh]  = iSsm(iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH ,i),SmoothPeriod,i,0);
        working[r][_haLow]   = iSsm(iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW  ,i),SmoothPeriod,i,1);
        working[r][_haClose] = iSsm(iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,i),SmoothPeriod,i,2);
        working[r][_haOpen]  = iSsm(iMA(NULL,0,1,0,MODE_SMA,PRICE_OPEN ,i),SmoothPeriod,i,3);
      
        //
        //
        //
        //
        //
      
        double haOpen  = (bufferHo[i+1]+bufferHc[i+1])/2.0; 
        double haClose = (working[r][_haOpen]+working[r][_haClose]+working[r][_haHigh]+working[r][_haLow])/4.0;
        double haHigh  = MathMax(working[r][_haHigh],MathMax(haOpen,haClose));
        double haLow   = MathMin(working[r][_haLow] ,MathMin(haOpen,haClose));

          if (haOpen<haClose) 
           {
              bufferHl[i]=haLow;
              bufferHh[i]=haHigh;
           } 
          else
           {
              bufferHh[i]=haLow;
              bufferHl[i]=haHigh;
           }
        bufferHo[i]=haOpen;
        bufferHc[i]=haClose;
        
        trend[i] = trend[i+1];
          if (bufferHo[i] < bufferHc[i]) trend[i] =  1;
          if (bufferHo[i] > bufferHc[i]) trend[i] = -1;    
    }   
    manageAlerts();
    return(0);
    }
    
    //
    //
    //
    //
    //
   
    int displace = -1; if (HistoOnFirst) displace = 1;
    limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
    for (i=limit;i>=0; i--)
    {
       int y = iBarShift(NULL,timeFrame,Time[i]);
       int x = iBarShift(NULL,timeFrame,Time[i+displace]);
          trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SmoothPeriod,4,y);
          if (x!=y)
          { 
             bufferHh[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SmoothPeriod,0,y);
             bufferHl[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SmoothPeriod,1,y);
             bufferHc[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SmoothPeriod,2,y);
             bufferHo[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SmoothPeriod,3,y);
          }
          else
          {
             bufferHh[i] = EMPTY_VALUE;
             bufferHl[i] = EMPTY_VALUE;
             bufferHc[i] = EMPTY_VALUE;
             bufferHo[i] = EMPTY_VALUE;
          }                 
    }
manageAlerts();
return(0);         
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workSsm[][8];
#define _price  0
#define _ssm    1

double workSsmCoeffs[][4];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define Pi 3.14159265358979323846264338327950288

//
//
//
//
//

double iSsm(double price, double period, int i, int instanceNo)
{
   if (ArrayRange(workSsm,0) !=Bars)                 ArrayResize(workSsm,Bars);
   if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
   if (workSsmCoeffs[instanceNo][_period] != period)
   {
      workSsmCoeffs[instanceNo][_period] = period;
      double a1 = MathExp(-1.414*Pi/period);
      double b1 = 2.0*a1*MathCos(1.414*Pi/period);
         workSsmCoeffs[instanceNo][_c2] = b1;
         workSsmCoeffs[instanceNo][_c3] = -a1*a1;
         workSsmCoeffs[instanceNo][_c1] = 1.0 - workSsmCoeffs[instanceNo][_c2] - workSsmCoeffs[instanceNo][_c3];
   }

   //
   //
   //
   //
   //

      i = Bars-i-1;
      int s = instanceNo*2;   
          workSsm[i][s+_price] = price;
          workSsm[i][s+_ssm]   = workSsmCoeffs[instanceNo][_c1]*(workSsm[i][s+_price]+workSsm[i-1][s+_price])/2.0 + 
                                 workSsmCoeffs[instanceNo][_c2]*workSsm[i-1][s+_ssm]                              + 
                                 workSsmCoeffs[instanceNo][_c3]*workSsm[i-2][s+_ssm];
   return(workSsm[i][s+_ssm]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" Heiken Ashi-super smoother  ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Heiken Ashi-super smoother "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

